'$Header: /home/cvs/cvsroot/fma/fma-scripting-framework.vbs,v 1.38 2004/03/20 18:42:27 streawkceur Exp $
'$Log: fma-scripting-framework.vbs,v $
'Revision 1.38  2004/03/20 18:42:27  streawkceur
'Using fma.Sleep now. Configurator forces script to reload settings after it saved th settings. Introduced Util.WaitForAppClose. Updated documentation. Updated Tools plugin, now it should work better. Updated Winamp plugin, now has a dialogue for setting winamp volume. Updated BramusICQ.
'
'Revision 1.37  2004/03/20 08:44:32  streawkceur
'Now _really_ added ActiveXManager
'
'Revision 1.36  2004/03/18 20:38:32  streawkceur
'Enhanced AutoMenu plugin. It now directly show a specified plugin menu instead of going to the main menu. See configurator.
'
'Revision 1.35  2004/03/18 15:58:08  streawkceur
'Checked all files for bad line ends. Now every file should work properly in Notepad.exe :)
'
'Revision 1.34  2004/03/18 15:25:52  streawkceur
'Keyword test
'

'FMA Script Framework
'Version 1.0 Beta
'Developed by streawkceur <twittek@smail.uni-koeln.de> and dVRVm

'Main Program
'Needs at least FMA 0.31f/0.32a

'FMA-Bugs/-Problems:
'-FMA could check AT command length before TX'ing. Must not be > 250 bytes! May cause an AT error otherwise
'-FMA could check <title> length in AT command that have a title element. It seems that titles must not be >15chars. May cause an AT error otherwise
'-FMA could check against selected item > num items in *EASM command. May cause an AT error otherwise
'-FMA could send multiple EASM commands without final flag to put long menus.

'Core-TODO:
'-Test key monitoring in minimized mode
'-Complete ManagedMenu:
'	-am.ClearMenu, am.Selected, am.DlgOption (which looks like a normal menu...)
'-Remove dummy key registration
'-Version Management?: Framework version, (FMA version), plugins version, plugins dependence on a specific framework version
'-Where is the WScript object? MsgBox WScript.ScriptFullName
'-Complete LinkedList (especially ArrayContainerClass)
'!!!-> See TODO's in each other source file

'DOC-TODO:
'	-More comprehensive LinkedList documentation
'	-Whole core documentation

'Plugins-TODO:
'-Core:
'	-Extend Demo Plugin
'-External:
'	-Finishing needed
'		-Camera: OBEX problem
'		-Winamp: Seek, DlgPercent buggy, winampcomlib doesn't support JumpToTime yet
'		-MasterVolume: DlgPercent buggy, Maybe register VolUp/-Down keys (on side of the phone)
'		-Tools: windows version independent shutdown etc.
'	-Testing
'		-BramusICQ
'		-Hauppauge WinTV (I'm not using WinTV...)
'		-ZoomPlayer
'		-iTunes
'	-Finished:
'		AutoMenu, BSPlayer, Configurator, FileExplorer, MediaCenter, MediaPlayer9, MoreTV, Mouse, MousePlus, OnCallPauseWA, PluginInfo, PowerDVD5, Powerpoint, Test, WinDVD

'Explicit variable declaration neccessary
Option Explicit

'Global Constants
'File operations
Public FILE_FOR_READING, FILE_FOR_WRITING
FILE_FOR_READING = 1
FILE_FOR_WRITING = 2

'Global external Objects
Public Fso, Shell
Set Fso   = CreateObject("Scripting.FileSystemObject")
Set Shell = CreateObject("WScript.Shell")

Dim ScriptFolder
'ScriptFolder = "C:\Programme\Fma\Script\fma\"
ScriptFolder = ".\sframework\"

'---> Import core classes
'-> Abstact Data Types
Execute(readFile(ScriptFolder & "core\Hash.vbs"))
Execute(readFile(ScriptFolder & "core\Stack.vbs"))
Execute(readFile(ScriptFolder & "core\LinkedList.vbs"))
'-> Managers
Execute(readFile(ScriptFolder & "core\EventManagerClass.vbs"))
Execute(readFile(ScriptFolder & "core\KeyManagerClass.vbs"))
Execute(readFile(ScriptFolder & "core\ManagedMenu.vbs"))
Execute(readFile(ScriptFolder & "core\PluginManagerClass.vbs"))
Execute(readFile(ScriptFolder & "core\ActiveXManagerClass.vbs"))
'-> Others
Execute(readFile(ScriptFolder & "core\QuickSort.vbs"))
Execute(readFile(ScriptFolder & "core\UtilClass.vbs"))
Execute(readFile(ScriptFolder & "core\DebugClass.vbs"))
Execute(readFile(ScriptFolder & "core\SettingsClass.vbs"))

'---> Create global objects
Public Util, Debug, QuickSorter, Settings, EventManager, KeyManager, PluginManager, ActiveXManager, EmptyMenu
Set Util           = New UtilClass
Set Debug          = Util.CreateObject("DebugClass", "Debug")
'Debug.SetDebugLevel DEBUG_LEVEL_OFF
'Debug.SetDebugLevel DEBUG_LEVEL_ERROR
'Debug.SetDebugLevel DEBUG_LEVEL_WARN
Debug.SetDebugLevel DEBUG_LEVEL_INFO
Debug.SetDebugLevel DEBUG_LEVEL_DEBUG
'Debug.SetDebugLevel DEBUG_LEVEL_NOFMA
Set QuickSorter    = New QuickSort
Set EmptyMenu      = New ManagedMenu
Set EventManager   = Util.CreateObject("EventManagerClass", "EventManager")
Set KeyManager     = Util.CreateObject("KeyManagerClass", "KeyManager")
Set Settings       = Util.CreateObject("SettingsClass", "Settings")
Set ActiveXManager = Util.CreateObject("ActiveXManagerClass", "ActiveXManager")
Set PluginManager  = Util.CreateObject("PluginManagerClass", "PluginManager")

'---> Import plugins
Execute PluginManager.LoaderString()

'Needed for importing classes and plugins
Function ReadFile(fileName)
	If Fso.FileExists(fileName) Then
		Dim File
		Set File = Fso.OpenTextFile(fileName, FILE_FOR_READING)
		ReadFile = File.ReadAll
		File.Close
	Else
		'Debug.ErrorMsg "ReadFile: File not found: " & fileName
		MsgBox "ReadFile: File not found: " & fileName
		ReadFile = ""
	End If
End Function

'''Delegate Events
Sub OnInit ()
	'Register a dummy key event since FMA will hang up when the first key is
	'registered (and keymonitoring is enabled) when the menu is shown.
	'This way, we will _always_ have keymonitoring on.
	KeyManager.RegisterKey "dummy", "'nuff done", STATE_PRESS, Nothing
	Debug.InfoMsg "FMA Scripting Framework loaded!"
	EventManager.OnEvent "Init", Array()
End Sub

Sub OnConnected ()
	Debug.DebugMsg "Initializing accessories menu"
	
	am.Init
	Util.SetStandbyScreenText "fma loaded"
	
	EventManager.OnEvent "Connected", Array()
End Sub

Sub OnConnectionLost ()
	EventManager.OnEvent "ConnectionLost", Array()
End Sub

Sub OnDisconnected ()
	EventManager.OnEvent "Disconnected", Array()
End Sub

Sub OnNewSMS ( Sender, Text )
	EventManager.OnEvent "NewSMS", Array( Sender, Text )
End Sub

' Hmm, no idea what the arguments do...
Sub OnCall (Caption, AlphaCaption, Number)
	EventManager.OnEvent "Call", Array( Caption, AlphaCaption, Number )
End Sub

Sub OnAMRoot ()
	EventManager.OnEvent "AMRoot", Array()
End Sub

Sub OnProximity ( State )
	EventManager.OnEvent "Proximity", Array( State )
End Sub

Sub OnMusicMute ( RtnString )
	EventManager.OnEvent "MusicMute", Array( RtnString )
End Sub

Sub OnKeyPress ( Key, Press )
	EventManager.OnEvent "KeyPress", Array( Key, Press )
	' The keypress manager is supposed to register itself in the event manager.
End Sub

