unit uAbout;

interface

{
*******************************************************************************
* Descriptions: About Box Implementation
* $Source: /cvsroot/fma/fma/uAbout.pas,v $
* $Locker:  $
*
* Todo:
*
* Change Log:
* $Log: uAbout.pas,v $
* Revision 1.25  2004/06/11 12:27:42  z_stoichev
* Updated project admins.
*
* Revision 1.24  2004/04/01 15:01:44  z_stoichev
* Donate link
*
* Revision 1.23  2004/03/28 20:46:16  z_stoichev
* GUI changes
*
* Revision 1.22  2004/03/08 12:20:14  z_stoichev
* Updated INC file comments
*
* Revision 1.21  2003/12/18 15:22:39  z_stoichev
* About image changed, layot changed.
*
* Revision 1.20  2003/12/11 14:54:31  z_stoichev
* Build Letter variable moved into INC file.
*
* Revision 1.19  2003/12/11 12:42:13  z_stoichev
* Patch 28e.
*
* Revision 1.18  2003/12/09 16:08:24  z_stoichev
* Added usage of uVersion unit.
*
* Revision 1.17  2003/12/09 12:05:25  z_stoichev
* Build 0.10.28c + 29a changes without new WaitComplete unit.
*
* Revision 1.16  2003/12/04 16:25:58  z_stoichev
* Update 29a.
*
* Revision 1.15  2003/12/03 16:18:00  z_stoichev
* Build increased to 0.1.0.29.
*
* Revision 1.14  2003/12/02 16:14:58  z_stoichev
* Patch 28d
*
* Revision 1.13  2003/11/28 09:38:07  z_stoichev
* Merged with branch-release-1-1 (Fma 0.10.28c)
*
* Revision 1.12.2.19  2003/11/27 12:58:01  z_stoichev
* Patch 28c.
*
* Revision 1.12.2.18  2003/11/26 12:24:05  z_stoichev
* Update to patch 28b.
*
* Revision 1.12.2.17  2003/11/21 10:56:36  z_stoichev
* Patch 28a
*
* Revision 1.12.2.16  2003/11/19 12:48:57  z_stoichev
* Build 28.
*
* Revision 1.12.2.15  2003/11/14 15:41:02  z_stoichev
* Updates for patch 27d.
*
* Revision 1.12.2.14  2003/11/13 16:49:03  z_stoichev
* Patch updated to 27c.
* Logo image transparancy issue fixed.
*
* Revision 1.12.2.13  2003/11/11 18:10:01  z_stoichev
* Use common background.
*
* Revision 1.12.2.12  2003/11/11 13:15:47  z_stoichev
* Update to patch b.
* GUI changed to allow more space.
*
* Revision 1.12.2.11  2003/11/10 16:07:57  z_stoichev
* Update for patch 27a.
*
* Revision 1.12.2.10  2003/11/10 14:03:09  z_stoichev
* RC3
*
* Revision 1.12.2.9  2003/11/07 16:35:52  z_stoichev
* Update to patch 20c.
*
* Revision 1.12.2.8  2003/11/07 09:48:42  z_stoichev
* Update to patch 20b.
* Wizard Image made common.
*
* Revision 1.12.2.7  2003/11/04 12:28:16  z_stoichev
* Update to patch a.
*
* Revision 1.12.2.6  2003/10/31 14:49:52  z_stoichev
* Added logo background and credits.
*
* Revision 1.12.2.5  2003/10/30 13:20:39  z_stoichev
* Update to patch d.
* Added Fma logo image.
*
* Revision 1.12.2.4  2003/10/29 14:58:06  z_stoichev
* Update to patch c.
*
* Revision 1.12.2.3  2003/10/28 12:56:06  z_stoichev
* Update to patch b.
*
* Revision 1.12.2.2  2003/10/27 15:38:29  z_stoichev
* Update to patch 19a.
*
* Revision 1.12.2.1  2003/10/27 07:22:54  z_stoichev
* Build 0.1.0 RC1 Initial Checkin.
*
* Revision 1.12  2003/10/24 16:59:10  z_stoichev
* Updated to patch 'd'.
*
* Revision 1.11  2003/10/24 12:28:43  z_stoichev
* Patch version "c".
*
* Revision 1.10  2003/10/23 11:36:54  z_stoichev
* Increased patch number, and font changed.
*
* Revision 1.9  2003/10/22 14:13:44  z_stoichev
* Add patch support (show a letter after build number).
*
* Revision 1.8  2003/10/16 11:13:35  z_stoichev
* Changed to show file build instead of
* product version.
*
* Revision 1.7  2003/10/14 08:24:07  z_stoichev
* Removed form transparency.
* Added me as a developer.
*
* Revision 1.6  2003/10/10 13:35:09  z_stoichev
* New about logo including T610 :-))
*
* Revision 1.5  2003/07/02 12:47:08  crino77
* changed role
*
* Revision 1.4  2003/01/30 04:12:54  warren00
* Added hyperlink url and dynamic version info. Configure version info in Project->Option
*
*
*******************************************************************************
}

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShellApi, LMDControl, LMDBaseControl,
  LMDBaseGraphicControl, LMDGraphicControl, LMDScrollText, Graphics,
  RxGIF, GIFImage;

(*
const
  // should be changed manualy when releasing a patch,
  // and should be cleared when releasing a new build version.

  // also keep minor changes patch by increase letters,
  // and majr changes patch by increaseing build number.
  BuildPatchLetter = '';

  // useful for monthly builds ala Xmas Edition.
  BuildFriendlyName = '';
*)

{ Following  include file contains the commented lines above.
  Its done to avoid CVS checkin/checkout on every single update. }

{$I uAbout.inc}

type
  TfrmAbout = class(TForm)
    Button1: TButton;
    Bevel2: TBevel;
    lbURL: TLabel;
    Panel1: TPanel;
    Bevel1: TBevel;
    lbVersion: TLabel;
    Bevel3: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LMDScrollText1: TLMDScrollText;
    Image1: TImage;
    Label3: TLabel;
    Label4: TLabel;
    Label9: TLabel;
    Image3: TImage;
    Label10: TLabel;
    Label11: TLabel;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure lbURLClick(Sender: TObject);
    procedure SendMailClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    Procedure LoadVersionInfo;
  public
    { Public declarations }
  end;

var
  frmAbout: TfrmAbout;

function GetBuildVersionDtl: string;

implementation

uses Unit1, uVersion;

{$R *.dfm}

function GetBuildVersionDtl: string;
begin
  Result := ExtractFileVersionInfo(Application.ExeName,'FileVersion') +
    BuildPatchLetter;
  if BuildFriendlyName <> '' then
    Result := Result + ' ' + BuildFriendlyName;
  if BuildPatchLetter <> '' then
    Result := Result + ' (patched)';
end;

{ TfrmAbout }

procedure TfrmAbout.LoadVersionInfo;
begin
  //lbProductName.Caption := ExtractFileVersionInfo(Application.ExeName,'ProductName');
  lbVersion.Caption := 'Version ' + GetBuildVersionDtl;
  lbURL.Caption := ExtractFileVersionInfo(Application.ExeName,'URL');
end;

procedure TfrmAbout.FormCreate(Sender: TObject);
begin
  Image1.Picture.Assign(Form1.BackgrImage.Picture);
  LoadVersionInfo;
end;

procedure TfrmAbout.lbURLClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(TLabel(Sender).Caption), '', '', SW_SHOWNORMAL);
end;

procedure TfrmAbout.SendMailClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar('mailto:' + TLabel(Sender).Caption), '', '', SW_SHOWNORMAL);
end;

procedure TfrmAbout.FormShow(Sender: TObject);
begin
  LMDScrollText1.Scroll := True;
end;

procedure TfrmAbout.FormHide(Sender: TObject);
begin
  LMDScrollText1.Scroll := False;
end;

procedure TfrmAbout.Button2Click(Sender: TObject);
begin
  { Note: this is perssonal donation link for Dako }
  ShellExecute(Handle, 'open', 'http://order.kagi.com/?6CYME&lang=en', '', '', SW_SHOWNORMAL);
end;

end.
