unit uDebug;

{
*******************************************************************************
* Descriptions: Debug log window implementation
* $Source: /cvsroot/fma/fma/uDebug.pas,v $
* $Locker:  $
*
* Todo:
*
* Change Log:
* $Log: uDebug.pas,v $
* Revision 1.5  2004/05/21 10:09:02  z_stoichev
* Changed logging handle routines.
*
* Revision 1.4  2003/11/28 09:38:07  z_stoichev
* Merged with branch-release-1-1 (Fma 0.10.28c)
*
* Revision 1.3.2.2  2003/10/28 10:15:35  z_stoichev
* Always show memo last line.
*
* Revision 1.3.2.1  2003/10/27 07:22:54  z_stoichev
* Build 0.1.0 RC1 Initial Checkin.
*
* Revision 1.3  2003/01/30 04:15:57  warren00
* Updated with header comments
*
*
*******************************************************************************
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Placemnt, Menus;

type
  TfrmDebug = class(TForm)
    Memo: TMemo;
    FormPlacement1: TFormPlacement;
    MainMenu1: TMainMenu;
    Log1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Clear1: TMenuItem;
    N2: TMenuItem;
    Close1: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure MemoChange(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDebug: TfrmDebug;

implementation

uses Unit1;

{$R *.dfm}

procedure TfrmDebug.MemoChange(Sender: TObject);
begin
  SaveAs1.Enabled := Memo.Text <> '';
  Clear1.Enabled := SaveAs1.Enabled;
  Memo.SelLength := 0;
  if not Visible then
    SendMessage(Memo.Handle,WM_VSCROLL,SB_THUMBPOSITION or ((Memo.Lines.Count-1) shl 16),0);
end;

procedure TfrmDebug.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmDebug.Clear1Click(Sender: TObject);
begin
  Memo.Lines.Clear;
  SaveAs1.Enabled := False;
  Clear1.Enabled := False;
end;

procedure TfrmDebug.SaveAs1Click(Sender: TObject);
begin
  SaveDialog1.InitialDir := ExtractFileDir(Application.ExeName);
  SaveDialog1.FileName := Caption + '.log';
  if SaveDialog1.Execute then begin
    Memo.Lines.SaveToFile(SaveDialog1.FileName);
    SaveAs1.Enabled := False;
  end;
end;

end.
