unit uEditContact;

{
*******************************************************************************
* Descriptions: Main Unit for FMA
* $Source: /cvsroot/fma/fma/uEditContact.pas,v $
* $Locker:  $
*
* Todo:
*    - add picture and sound support
*
* Change Log:
* $Log: uEditContact.pas,v $
* Revision 1.12  2004/05/21 14:39:47  z_stoichev
* Fixed Contact name changes not saved
* Added Contact Display name support
*
* Revision 1.11  2004/05/19 18:34:15  z_stoichev
* Build 0.1.0.35c
*
* Revision 1.10  2004/04/01 15:07:47  z_stoichev
* Apply button fixes
*
* Revision 1.9  2004/03/26 18:37:39  z_stoichev
* Build 0.1.0.35 RC5
*
* Revision 1.8  2004/03/11 12:44:59  z_stoichev
* Fixed Font Charset.
*
* Revision 1.7  2004/01/28 17:12:14  z_stoichev
* Allow editing ME when no obex.
*
* Revision 1.6  2003/12/11 12:39:55  z_stoichev
* Fixed upload and select issue.
*
* Revision 1.5  2003/12/02 16:39:16  z_stoichev
* Fixed error when editing own card.
*
* Revision 1.4  2003/12/01 16:01:38  z_stoichev
* Support for Own card editing.
* Auto set picture on upload.
*
* Revision 1.3  2003/11/28 09:38:07  z_stoichev
* Merged with branch-release-1-1 (Fma 0.10.28c)
*
* Revision 1.2.2.13  2003/11/26 12:25:01  z_stoichev
* Allow 'p' char (pause)  into numbers.
* Tab settings update on activate fixed.
*
* Revision 1.2.2.12  2003/11/21 13:24:15  z_stoichev
* Fixed Show window caption, when names are empty.
* Allow creating new contact with default cell number.
*
* Revision 1.2.2.11  2003/11/19 13:28:40  z_stoichev
* Cell word changed to Mobile.
*
* Revision 1.2.2.10  2003/11/19 12:55:00  z_stoichev
* Allow # and * in numbers.
*
* Revision 1.2.2.9  2003/11/11 18:12:23  z_stoichev
* Contact personalization changes.
*
* Revision 1.2.2.8  2003/11/11 13:24:02  z_stoichev
* Add personalization support.
*
* Revision 1.2.2.7  2003/11/10 14:03:09  z_stoichev
* RC3
*
* Revision 1.2.2.6  2003/11/07 13:56:49  z_stoichev
* Add support for editing SIM records.
*
* Revision 1.2.2.5  2003/11/07 11:16:54  z_stoichev
* Fixed edit contact do not apply changes.
*
* Revision 1.2.2.4  2003/10/30 13:25:46  z_stoichev
* Fixed phone numbers sanity check.
* Added Beep on wrong char input.
*
* Revision 1.2.2.3  2003/10/28 12:46:56  z_stoichev
* Add default number selection.
* Dont update contact as modified if only
* custom Fma data is modified.
*
* Revision 1.2.2.2  2003/10/27 15:23:56  z_stoichev
* Clear cached information button is added.
*
* Revision 1.2.2.1  2003/10/27 07:22:54  z_stoichev
* Build 0.1.0 RC1 Initial Checkin.
*
* Revision 1.2  2003/10/24 12:32:21  z_stoichev
* Full name is updated on name, surname change.
* Show some default picture and sound infos.
* Fixed: Name + surname length + space = 30.
*
* Revision 1.1  2003/10/23 11:32:41  z_stoichev
* Initial checkin.
*
*
*
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, TntStdCtrls, ComCtrls, Buttons, uSyncPhonebook,
  Menus, TntComCtrls, MPlayer, GR32_Image;

type
  TfrmEditContact = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Image1: TImage;
    Bevel1: TBevel;
    Label1: TLabel;
    txtTitle: TTntEdit;
    txtName: TTntEdit;
    Label2: TLabel;
    Label4: TLabel;
    txtOrganization: TTntEdit;
    txtEmail: TTntEdit;
    Label5: TLabel;
    Bevel2: TBevel;
    Label6: TLabel;
    txtHome: TTntEdit;
    Label7: TLabel;
    txtWork: TTntEdit;
    Label8: TLabel;
    txtCell: TTntEdit;
    Label9: TLabel;
    txtFax: TTntEdit;
    Label10: TLabel;
    txtOther: TTntEdit;
    TabSheet2: TTabSheet;
    OkButton: TButton;
    CancelButton: TButton;
    ApplyButton: TButton;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    btnPicSel: TButton;
    Label12: TLabel;
    Label13: TLabel;
    lblPicDim: TLabel;
    Label15: TLabel;
    imgDim: TImage;
    lblPicName: TLabel;
    lblPicSize: TLabel;
    btnPicNew: TButton;
    GroupBox2: TGroupBox;
    btnPicDel: TButton;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    btnSndNew: TButton;
    btnSndDel: TButton;
    btnSndSel: TButton;
    imgSnd: TImage;
    lblSndType: TLabel;
    lblSndName: TLabel;
    lblSndSize: TLabel;
    Label11: TLabel;
    lblPicPal: TLabel;
    TabSheet3: TTabSheet;
    Label18: TLabel;
    ResetButton: TButton;
    Label19: TLabel;
    TabSheet4: TTabSheet;
    GroupBox3: TGroupBox;
    cbDefaultNum: TComboBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    PopupMenu1: TPopupMenu;
    MediaPlayer1: TMediaPlayer;
    SelImage: TImage32;
    Label24: TLabel;
    txtDisplayAs: TTntEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure txtChange(Sender: TObject);
    procedure customChange(Sender: TObject);
    procedure txtNameExit(Sender: TObject);
    procedure ApplyButtonClick(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure txtTelKeyPress(Sender: TObject; var Key: Char);
    procedure ResetButtonClick(Sender: TObject);
    procedure TabSheet4Show(Sender: TObject);
    procedure txtPhoneChange(Sender: TObject);
    procedure txtPhoneEnter(Sender: TObject);
    procedure btnPicSelClick(Sender: TObject);
    procedure btnSndSelClick(Sender: TObject);
    procedure OnPicSelClick(Sender: TObject);
    procedure OnSndSelClick(Sender: TObject);
    procedure btnPicDelClick(Sender: TObject);
    procedure btnSndDelClick(Sender: TObject);
    procedure MediaPlayer1Click(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure PageControl1Change(Sender: TObject);
    procedure btnUploadClick(Sender: TObject);
  private
    { Private declarations }
    FPhonePrev: string;
    FUseSIMMode: boolean;
    FUseOwnMode: boolean;
    procedure DoSanityCheck;
    procedure LoadContactData;
    procedure SaveContactData;
    procedure ShowFullName;
    procedure UpdateDefNum(SetTo: integer = 0);
    procedure UpdatePersonalize;
    procedure Set_UseSIMMode(const Value: boolean);
    procedure Set_UseOwnMode(const Value: boolean);
    procedure SelectFile(Pos: TPoint; FileType: byte; Selected: WideString = '');
  public
    { Public declarations }
    MaxFullNameLen: integer;
    IsNew,Modified,customModified: boolean;
    contact: TContactData;
  published
    property UseSIMMode: boolean read FUseSIMMode write Set_UseSIMMode default False;
    property UseOwnMode: boolean read FUseOwnMode write Set_UseOwnMode default False;
  end;

var
  frmEditContact: TfrmEditContact;

implementation

uses Unit1;

{$R *.dfm}

procedure TfrmEditContact.FormCreate(Sender: TObject);
begin
  lblPicDim.Left := imgDim.Left + imgDim.Width + 4;
  lblPicName.Left := Label13.Left + Label13.Width + 4;
  lblPicSize.Left := Label15.Left + Label15.Width + 4;
  lblPicPal.Left := Label11.Left + Label11.Width + 4;
  lblSndType.Left := imgSnd.Left + imgSnd.Width + 4;
  lblSndName.Left := Label14.Left + Label14.Width + 4;
  lblSndSize.Left := Label16.Left + Label16.Width + 4;
{$IFNDEF VER150}
  Form1.ThemeManager1.CollectForms(Self);
{$ENDIF}
end;

procedure TfrmEditContact.FormShow(Sender: TObject);
begin
  MaxFullNameLen := txtName.MaxLength;
  LoadContactData;
  PageControl1.ActivePageIndex := 0;
  txtName.SetFocus;
end;

procedure TfrmEditContact.LoadContactData;
var
  c: TColor;
  b: boolean;
  procedure UpdateTelView(var Item: TTntEdit);
  begin
    { Always enable, and disable only empty Edits }
    if b or (Item.Text = '') then begin
      Item.Enabled := b;
      Item.Color := c;
    end;
  end;
begin
  if FUseSIMMode then c := clBtnFace else c := clWindow;
  b := not FUseSIMMode;
  // contact
  txtTitle.Text := contact.title;
  txtName.Text := contact.name;
  if contact.surname <> '' then
    txtName.Text := txtName.Text + ' ' + contact.surname;
  txtDisplayAs.Text := contact.displayname;
  txtOrganization.Text := contact.org;
  txtEmail.Text := contact.email;
  txtHome.Text := contact.home;
  txtWork.Text := contact.work;
  txtCell.Text := contact.cell;
  txtFax.Text := contact.fax;
  txtOther.Text := contact.other;
  ShowFullName;
  if not (FUseSIMMode or FUseOwnMode) then begin
    // Personalize, will fill data on tabsheet open
    btnPicDel.Click;
    btnSndDel.Click;
    // Preferences
    UpdateDefNum(contact.DefaultIndex);
  end;  
  { Leave only used field for editing, or enable all fields for new contacts }
  if FUseSIMMode then begin
    if (txtCell.Text <> '') or (txtHome.Text <> '') or (txtWork.Text <> '') or
      (txtFax.Text <> '') or (txtOther.Text <> '') then begin
      UpdateTelView(txtCell);
      UpdateTelView(txtHome);
      UpdateTelView(txtWork);
      UpdateTelView(txtFax);
      UpdateTelView(txtOther);
    end
    else if not Form1.frmSIMEdit.IsMEMode then begin
      { For SIM card enable only cell phone }
      UpdateTelView(txtHome);
      UpdateTelView(txtWork);
      UpdateTelView(txtFax);
      UpdateTelView(txtOther);
    end;
  end;
  // done
  ApplyButton.Enabled := False;
  Modified := False;
  customModified := False;
end;

procedure TfrmEditContact.SaveContactData;
var
  i: integer;
  s,a: WideString;
begin
  contact.title := txtTitle.text;
  a := GetContactFullName(@contact);
  s := Trim(txtName.text);
  i := Pos(' ',s);
  if i = 0 then begin
    contact.name := s;
    contact.surname := '';
  end
  else begin
    contact.name := Copy(s,1,i-1);
    Delete(s,1,i);
    contact.surname := Trim(s);
  end;
  s := GetContactFullName(@contact);
  if WideCompareText(a,s) <> 0 then
    { If name/surname are changed, reset display name, since SE T610
      doesnt support displayname vCard peoperty }
    txtDisplayAs.Text := s;
  contact.displayname := txtDisplayAs.Text;
  contact.org := txtOrganization.text;
  contact.email := txtEmail.text;
  contact.home := txtHome.text;
  contact.work := txtWork.text;
  contact.cell := txtCell.text;
  contact.fax := txtFax.text;
  contact.other := txtOther.text;
  if not (FUseSIMMode or FUseOwnMode) then begin
    contact.DefaultIndex := cbDefaultNum.ItemIndex;
    contact.picture := lblPicName.Caption;
    contact.sound := lblSndName.Caption;
  end;  
  { Dont change modified flags here, since we'll use them in SyncPhonebook.
    Only disable apply button. }
  ApplyButton.Enabled := False;
end;

procedure TfrmEditContact.txtChange(Sender: TObject);
begin
  ApplyButton.Enabled := not IsNew;
  Modified := True;
end;

procedure TfrmEditContact.txtNameExit(Sender: TObject);
begin
  ShowFullName;
end;

procedure TfrmEditContact.ApplyButtonClick(Sender: TObject);
begin
  DoSanityCheck;
  SaveContactData;
end;

procedure TfrmEditContact.OkButtonClick(Sender: TObject);
begin
  DoSanityCheck;
  if ApplyButton.Enabled or IsNew then
    SaveContactData;
  ModalResult := mrOk;  
end;

procedure TfrmEditContact.ShowFullName;
var
  s: WideString;
begin
  s := Trim(txtName.Text);
  if txtDisplayAs.Text = '' then
    txtDisplayAs.Text := s;
  if s <> '' then
    if FUseOwnMode then
      Caption := 'Own Business Card - '+s
    else
      Caption := 'Contact - '+s
  else
    Caption := 'Contact';
end;

procedure TfrmEditContact.txtTelKeyPress(Sender: TObject; var Key: Char);
begin
  case ord(Key) of
    8, 48..57: ;
    35, 42: ; // # and * (for special service numbers)
    3, 22, 24, 26: ; //escape CTRL+C,V,X,Z ;)
    43: with (Sender as TTntEdit) do begin
      if (Pos('+',Text) <> 0) or (SelStart <> 0) then begin
        Key := #0;     //only the first char can be '+'
        Beep;
      end;
    end;
    112: ; // p (pause)
    else begin
      Key := #0;
      Beep;
    end;
  end;
end;

procedure TfrmEditContact.ResetButtonClick(Sender: TObject);
begin
  FillChar(contact.Position,SizeOf(contact.Position),0);
  ApplyButton.Enabled := not IsNew;
  customModified := True;
end;

procedure TfrmEditContact.TabSheet4Show(Sender: TObject);
begin
  UpdateDefNum;
end;

procedure TfrmEditContact.UpdateDefNum(SetTo: integer);
var
  selpos: integer;
begin
  if SetTo = 0 then selpos := cbDefaultNum.ItemIndex else selpos := SetTo;
  cbDefaultNum.Items.Clear;
  // see TContactData.DefaultIndex
  // 0 none;1 cell;2 work;3 home;4 other
  cbDefaultNum.Items.Add('None');
  if txtCell.Text <> '' then cbDefaultNum.Items.Add('Mobile ['+txtCell.Text+']');
  if txtWork.Text <> '' then cbDefaultNum.Items.Add('Work ['+txtWork.Text+']');
  if txtHome.Text <> '' then cbDefaultNum.Items.Add('Home ['+txtHome.Text+']');
  if txtOther.Text <> '' then cbDefaultNum.Items.Add('Other ['+txtOther.Text+']');
  if (selpos < 0) or (selpos >= cbDefaultNum.Items.Count) then
    selpos := 0; // Out of range goes to None
  cbDefaultNum.ItemIndex := selpos;
end;

procedure TfrmEditContact.customChange(Sender: TObject);
begin
  ApplyButton.Enabled := not IsNew;
  customModified := True;
end;

procedure TfrmEditContact.txtPhoneChange(Sender: TObject);
const
  sem: boolean = False;
var
  i: integer;
  s: string;
  b: boolean;
begin
  if not sem then
    try
      sem := true;
      with (Sender as TTntEdit) do begin
        b := False;
        s := Text;
        i := 1;
        while i <= Length(s) do begin
          if ((i > 1) and (s[1] = '+') and (s[i] = '+')) or
            (Pos('+',s) > 1) or not (s[i] in ['+','0'..'9','#','*','p']) then begin
              Delete(s,i,1);
              b := True;
            end
          else
            inc(i);
        end;
        if s <> Text then Text := s;
        if s <> FPhonePrev then begin
          FPhonePrev := s;
          ApplyButton.Enabled := not IsNew;
          Self.Modified := True;
        end;
        if b then Beep;
      end;
    finally
      sem := False;
    end;
end;

procedure TfrmEditContact.txtPhoneEnter(Sender: TObject);
begin
  FPhonePrev := (Sender as TTntEdit).Text;
end;

procedure TfrmEditContact.Set_UseSIMMode(const Value: boolean);
var
  i: integer;
  c: TColor;
  b: boolean;
begin
  FUseSIMMode := Value;
  if Value then c := clBtnFace else c := clWindow;
  b := not Value;
  txtTitle.Enabled := b;
  txtTitle.Color := c;
  txtOrganization.Enabled := b;
  txtOrganization.Color := c;
  txtEmail.Enabled := b;
  txtEmail.Color := c;
  for i := 1 to PageControl1.PageCount-1 do begin
    PageControl1.Pages[i].TabVisible := b;
  end;
end;

procedure TfrmEditContact.SelectFile(Pos: TPoint; FileType: byte; Selected: WideString);
var
  m: TMenuItem;
  Node,Item: TTntTreeNode;
  Offline: boolean;
  What: string;
  ImgIdx: integer;
  rec: TSearchRec;
begin
  Offline := not Form1.FConnected or not Form1.FUseObex;
  PopupMenu1.Items.Clear;
  if Offline then begin
    case FileType of
      0: What := '\pic\*.*';
      1: What := '\snd\*.*';
    end;
    if FindFirst(ExePath+'data\'+Form1.PhoneIdentity+What,faAnyFile,rec) = 0 then
    try
      repeat
        ImgIdx := Form1.ExplorerFindExtImage(ExtractFileExt(rec.Name));
        if ImgIdx = -1 then continue;
        m := TMenuItem.Create(nil);
        try
          m.AutoHotkeys := maManual;
          m.Caption := rec.Name;
          m.Tag := rec.Size;
          m.Hint := rec.Name; // ignored in offline mode
          m.ImageIndex := ImgIdx;
          case FileType of
            0: m.OnClick := OnPicSelClick;
            1: m.OnClick := OnSndSelClick;
          end;
          if Selected <> '' then begin
            if WideCompareText(rec.Name,Selected) = 0 then begin
              m.Click;
              m.Free;
              break;
            end;
            m.Free;
          end
          else
            PopupMenu1.Items.Add(m);
        except
          m.Free;
        end;
      until FindNext(rec) <> 0;
    finally
      FindClose(rec);
    end;
  end
  else begin
    Node := Form1.FindObexFolderNode(FileType);
    if Assigned(Node) then begin
      Item := Node.getFirstChild;
      while Item <> nil do
      try
        m := TMenuItem.Create(nil);
        try
          m.AutoHotkeys := maManual;
          m.Caption := Item.Text;
          m.Tag := Item.StateIndex;
          m.Hint := Node.Text + '/' + Item.Text;
          m.ImageIndex := Item.ImageIndex;
          case FileType of
            0: m.OnClick := OnPicSelClick;
            1: m.OnClick := OnSndSelClick;
          end;
          if Selected <> '' then begin
            if WideCompareText(Item.Text,Selected) = 0 then begin
              m.Click;
              m.Free;
              break;
            end;
            m.Free;
          end
          else
            PopupMenu1.Items.Add(m);
        except
          m.Free;
        end;
      finally
        Item := Node.GetNextChild(Item);
      end;
    end;
  end;  
  if PopupMenu1.Items.Count <> 0 then begin
    PopupMenu1.Popup(pos.X,pos.Y);
  end;
end;

procedure TfrmEditContact.btnPicSelClick(Sender: TObject);
var
  p: TPoint;
begin
  p := btnPicSel.ClientToScreen(Point(0,btnPicSel.Height));
  SelectFile(p,0);
end;

procedure TfrmEditContact.btnSndSelClick(Sender: TObject);
var
  p: TPoint;
begin
  p := btnSndSel.ClientToScreen(Point(0,btnSndSel.Height));
  SelectFile(p,1);
end;

procedure TfrmEditContact.OnPicSelClick(Sender: TObject);
var
  Filename,Fullpath,Objectname: WideString;
  Filesize: integer;
begin
  btnPicSel.Enabled := False;
  btnSndSel.Enabled := False;
  try
    Objectname := (Sender as TMenuItem).Hint;
    Filename := (Sender as TMenuItem).Caption;
    Filesize := (Sender as TMenuItem).Tag;
    Fullpath := ExePath+'data\'+Form1.PhoneIdentity+'\pic\';

    lblPicDim.Caption := '';
    lblPicSize.Caption := '';
    lblPicPal.Caption := '';
    lblPicName.Caption := '(Loading '+Filename+'...)';

    try
      ForceDirectories(Fullpath);
      if Form1.FConnected and Form1.FUseObex and not FileExists(Fullpath+Filename) then
        Form1.ObexGetFile(Fullpath+Filename,Objectname,False);

      SelImage.Bitmap.LoadFromFile(Fullpath+Filename);
      SelImage.Visible := True;
    except
      btnPicDel.Click;
      raise;
    end;

    lblPicName.Caption := Filename;
    lblPicDim.Caption := Format('%dx%d (%dx%d pixels)',[SelImage.Width,SelImage.Height,
      SelImage.Bitmap.BitmapInfo.bmiHeader.biWidth,-SelImage.Bitmap.BitmapInfo.bmiHeader.biHeight]);
    lblPicSize.Caption := Format('%.1n KB (%d bytes)',[Filesize / 1024,Filesize]);
    case SelImage.Bitmap.BitmapInfo.bmiHeader.biBitCount of
       8: lblPicPal.Caption := 'Low-Color (256 colors)';
      16: lblPicPal.Caption := 'Hi-Color (65535 colors)';
      24: lblPicPal.Caption := 'True-Color (24-bit colors)';
      32: lblPicPal.Caption := 'True-Color (32-bit colors)';
      else lblPicPal.Caption := 'Low-Color (<256 colors)';
    end;
    ApplyButton.Enabled := not IsNew;
    customModified := True;
  finally
    btnPicSel.Enabled := True;
    btnSndSel.Enabled := True;
  end;
end;

procedure TfrmEditContact.OnSndSelClick(Sender: TObject);
var
  Filename,Fullpath,Objectname: WideString;
  Filesize: integer;
begin
  btnPicSel.Enabled := False;
  btnSndSel.Enabled := False;
  try
    Objectname := (Sender as TMenuItem).Hint;
    Filename := (Sender as TMenuItem).Caption;
    Filesize := (Sender as TMenuItem).Tag;
    Fullpath := ExePath+'data\'+Form1.PhoneIdentity+'\snd\';

    lblSndType.Caption := '';
    lblSndSize.Caption := '';
    lblSndName.Caption := '(Loading '+Filename+'...)';

    try
      ForceDirectories(Fullpath);
      if Form1.FConnected and Form1.FUseObex and not FileExists(Fullpath+Filename) then
        Form1.ObexGetFile(Fullpath+Filename,Objectname,False);

      MediaPlayer1.FileName := Fullpath+Filename;
      MediaPlayer1.Enabled := True;
    except
      btnSndDel.Click;
      raise;
    end;

    lblSndName.Caption := Filename;
    lblSndSize.Caption := Format('%.1n KB (%d bytes)',[Filesize / 1024,Filesize]);
    try
      MediaPlayer1.Open;
      lblSndType.Caption := Format('Track length is %d samples (Custom format)',[MediaPlayer1.TrackLength[1]]);
    except
      lblSndType.Caption := 'Unknown (Unsupported format)';
      MediaPlayer1.Enabled := False;
    end;
    ApplyButton.Enabled := not IsNew;
    customModified := True;
  finally
    btnPicSel.Enabled := True;
    btnSndSel.Enabled := True;
  end;
end;

procedure TfrmEditContact.btnPicDelClick(Sender: TObject);
begin
  if lblPicName.Caption <> '' then begin
    ApplyButton.Enabled := not IsNew;
    customModified := True;
  end;  
  lblPicDim.Caption := '128x127 (0x0 pixels)';
  lblPicName.Caption := '';
  lblPicSize.Caption := '0,0 KB (0 bytes)';
  lblPicPal.Caption := 'Hi-Color (65535 colors)';
  SelImage.Bitmap.Clear;
  SelImage.Visible := False;
end;

procedure TfrmEditContact.btnSndDelClick(Sender: TObject);
begin
  if lblSndName.Caption <> '' then begin
    ApplyButton.Enabled := not IsNew;
    customModified := True;
  end;  
  lblSndType.Caption := '(polyphonic stereo sound, supported by phone)';
  lblSndName.Caption := '';
  lblSndSize.Caption := '0,0 KB (0 bytes)';
  MediaPlayer1.Close;
  MediaPlayer1.Enabled := False;
end;

procedure TfrmEditContact.UpdatePersonalize;
var
  m: TMenuItem;
  f: TFileStream;
  amod,cmod,OldApply: boolean;
  procedure LoadFile(fname: string; ftype: byte);
  var
    dir: string;
  begin
    { Emulate popup menu click here in order to select default
      contact picture/sound file. }
    case ftype of
      0: dir := '\pic\';
      1: dir := '\snd\';
    end;
    m := TMenuItem.Create(nil);
    try
      m.Caption := fname;
      try
        f := TFileStream.Create(ExePath+'data\'+Form1.PhoneIdentity+dir+fname,fmOpenRead);
        try
          m.Tag := f.Size;
        finally
          f.Free;
        end;
      except
        m.Tag := 0;
      end;
      case ftype of
        0: OnPicSelClick(m);
        1: OnSndSelClick(m);
      end;
    finally
      m.Free;
    end;
  end;
begin
  OldApply := ApplyButton.Enabled;
  { Show window while updateing }
  TabSheet2.Update;
  amod := Modified;
  cmod := customModified;
  { Load personalization files on tabsheet enter }
  if (lblPicName.Caption = '') and (contact.picture <> '') then
    LoadFile(contact.picture,0);
  if (lblSndName.Caption = '') and (contact.sound <> '') then
    LoadFile(contact.sound,1);
  Modified := amod;
  customModified := cmod;
  ApplyButton.Enabled := OldApply;
end;

procedure TfrmEditContact.MediaPlayer1Click(Sender: TObject;
  Button: TMPBtnType; var DoDefault: Boolean);
begin
  if Button = btStop then MediaPlayer1.Rewind;
end;

procedure TfrmEditContact.PageControl1Change(Sender: TObject);
begin
  case PageControl1.ActivePageIndex of
    1: UpdatePersonalize;
    2: UpdateDefNum;
  end;
end;

procedure TfrmEditContact.Set_UseOwnMode(const Value: boolean);
var
  i: integer;
begin
  FUseOwnMode := Value;
  try
    for i := 0 to ComponentCount-1 do
    if (Components[i] is TTabSheet) and (Components[i] <> TabSheet1) then
      if Value then
        (Components[i] as TTabSheet).PageControl := nil
      else
        (Components[i] as TTabSheet).PageControl := PageControl1;
  except
  end;
end;

procedure TfrmEditContact.btnUploadClick(Sender: TObject);
var
  m: TMenuItem;
  ObjType: integer;
begin
  btnPicNew.Enabled := False;
  btnSndNew.Enabled := False;
  try
    ObjType := TButton(Sender).Tag;
    Form1.RequestConnection;
    Form1.ActionToolsUpload.Execute;
    m := TMenuItem.Create(nil);
    try
      m.AutoHotkeys := maManual;
      m.Caption := ExtractFileName(Form1.OpenDialog1.FileName);
      m.Hint := Form1.FindObexFolderName(ObjType)+'/'+m.Caption;
      if ObjType = 0 then m.OnClick := OnPicSelClick
        else m.OnClick := OnSndSelClick;
      m.Click;
    finally
      m.Free;
    end;
  finally
    btnPicNew.Enabled := True;
    btnSndNew.Enabled := True;
  end;
end;

procedure TfrmEditContact.DoSanityCheck;
var
  TelCnt: integer;
begin
  { check name }
  if Trim(txtName.Text) = '' then
    raise EConvertError.Create('You have to enter contact name');
  if Pos('"',txtName.Text) <> 0 then
    {
    if not FUseSIMMode then begin
      Form1.ShowBaloonInfo('Hint: Quotes are allowed in contact name but if you copy this contact to SIM '+
        'card the entire name will be discharged.',10);
    end
    else
      raise EConvertError.Create('Quotes are not allowed in contact name');
    }
    if FUseSIMMode then
      raise EConvertError.Create('Quotes are not allowed in contact name');
  { check numbers }
  TelCnt := 0;
  if txtCell.Text <> ''  then inc(TelCnt);
  if txtHome.Text <> ''  then inc(TelCnt);
  if txtWork.Text <> ''  then inc(TelCnt);
  if txtFax.Text <> ''   then inc(TelCnt);
  if txtOther.Text <> '' then inc(TelCnt);
  if TelCnt = 0 then
     raise EConvertError.Create('You have to enter contact phone number');
  if FUseSIMMode and (TelCnt > 1) then
    raise EConvertError.Create('You have to enter only one phone number');
end;

end.
