unit uInfoView;

{
*******************************************************************************
* Descriptions: Phone Info view implementation
* $Source: /cvsroot/fma/fma/uInfoView.pas,v $
* $Locker:  $
*
* WARNING: ActivityLog should be on top of all other widgets in the panel.
*
* Todo:
*
* Change Log:
* $Log: uInfoView.pas,v $
* Revision 1.14  2004/06/11 12:28:18  z_stoichev
* Fixed horizontal splitter on resize update.
*
* Revision 1.13  2004/05/21 12:02:16  z_stoichev
* Split vertically Fma Today page
* Activity Log has been removed.
*
* Revision 1.12  2004/05/21 10:09:03  z_stoichev
* Changed logging handle routines.
*
* Revision 1.11  2004/05/19 18:34:16  z_stoichev
* Build 0.1.0.35c
*
* Revision 1.10  2004/04/01 15:30:28  z_stoichev
* New Calls data format support
*
* Revision 1.9  2004/03/28 22:12:06  z_stoichev
* added some more link buttons
*
* Revision 1.8  2004/03/26 18:37:39  z_stoichev
* Build 0.1.0.35 RC5
*
* Revision 1.7  2003/12/12 16:57:18  z_stoichev
* Changed diagram: dont scroll with mouse, show legend when wide.
*
* Revision 1.6  2003/11/28 09:38:07  z_stoichev
* Merged with branch-release-1-1 (Fma 0.10.28c)
*
* Revision 1.5.2.5  2003/11/11 18:11:45  z_stoichev
* GUI changes. add methods to manipulate GUI.
*
* Revision 1.5.2.4  2003/11/10 14:03:09  z_stoichev
* RC3
*
* Revision 1.5.2.3  2003/10/30 13:29:52  z_stoichev
* Unicode support in Activity log.
* GUI changes.
*
* Revision 1.5.2.2  2003/10/28 10:15:35  z_stoichev
* Always show memo last line.
*
* Revision 1.5.2.1  2003/10/27 07:22:54  z_stoichev
* Build 0.1.0 RC1 Initial Checkin.
*
* Revision 1.5  2003/10/24 12:35:38  z_stoichev
* Added connection commands log.
*
* Revision 1.4  2003/10/16 15:29:04  z_stoichev
* Diagram settigs changed alot.
* Now diagram shows last 1 minute of statistics.
* Charge is shown on battery's axe, because
* they have similar values.
*
* Revision 1.3  2003/01/30 04:15:57  warren00
* Updated with header comments
*
*
*******************************************************************************
}

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TeEngine, Series, TeeProcs, Chart, ComCtrls,
  TntStdCtrls, ImgList, jpeg, Buttons, LMDControl, LMDBaseControl,
  LMDBaseGraphicControl, LMDGraphicControl, LMDBaseMeter,
  LMDCustomProgressFill, LMDProgressFill, TntComCtrls, LMDFill, Menus;

type
  TfrmInfoView = class(TFrame)
    Panel1: TPanel;
    Image7: TImage;
    Bevel6: TBevel;
    Label27: TLabel;
    Label26: TLabel;
    wRecentCallsNum: TTntLabel;
    Label22: TLabel;
    Image5: TImage;
    Bevel4: TBevel;
    Label21: TLabel;
    Label15: TLabel;
    sbReadInbox: TSpeedButton;
    Image3: TImage;
    Label11: TLabel;
    wInboxNew: TLabel;
    Bevel2: TBevel;
    Label17: TLabel;
    Label10: TLabel;
    Panel2: TPanel;
    Image8: TImage;
    Bevel7: TBevel;
    Label31: TLabel;
    Label30: TLabel;
    Image6: TImage;
    Label23: TLabel;
    Bevel5: TBevel;
    Label25: TLabel;
    Label24: TLabel;
    sbSendOubox: TSpeedButton;
    Image4: TImage;
    Label20: TLabel;
    wOutboxNew: TLabel;
    Bevel3: TBevel;
    Label19: TLabel;
    Label18: TLabel;
    Panel3: TPanel;
    wOperator: TLabel;
    wSignal: TLabel;
    Image2: TImage;
    wDate: TTntLabel;
    Label9: TLabel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    lbvbat: TLabel;
    lbicharge: TLabel;
    lbcyclescharge: TLabel;
    Label7: TLabel;
    lbdcio: TLabel;
    Label3: TLabel;
    lbiphone: TLabel;
    Label5: TLabel;
    lbtempbatt: TLabel;
    Label6: TLabel;
    lbtempphone: TLabel;
    Label12: TLabel;
    lbManufacturer: TLabel;
    lbModel: TLabel;
    Label13: TLabel;
    Label16: TLabel;
    lbSWRevision: TLabel;
    lbSerialNumber: TLabel;
    Label14: TLabel;
    Label28: TLabel;
    lbPower: TLabel;
    lvCalls: TTntListView;
    LMDFill2: TLMDFill;
    DiagramPanel: TPanel;
    Chart1: TChart;
    Series1: TLineSeries;
    Series3: TLineSeries;
    Series2: TLineSeries;
    spNewMsg: TSpeedButton;
    wMissedCallsNum: TLabel;
    PopupMenu2: TPopupMenu;
    CallContact1: TMenuItem;
    MessageContact1: TMenuItem;
    sbCheckInbox: TSpeedButton;
    Label29: TLabel;
    wBattery: TLabel;
    lblTimeLeft: TLabel;
    Label8: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Bevel1: TBevel;
    Image9: TImage;
    Label34: TLabel;
    wMENum: TLabel;
    SpeedButton1: TSpeedButton;
    sbMESync: TSpeedButton;
    Label35: TLabel;
    wCharge: TLabel;
    lvMissed: TTntListView;
    BigImage: TImage;
    sbReadArchive: TSpeedButton;
    sbNewContact: TSpeedButton;
    Splitter1: TSplitter;
    procedure sbSendOuboxClick(Sender: TObject);
    procedure sbReadSMSClick(Sender: TObject);
    procedure ListViewResize(Sender: TObject);
    procedure ListViewCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure spMissedClick(Sender: TObject);
    procedure spNewMsgClick(Sender: TObject);
    procedure sbCheckInboxClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure sbMESyncClick(Sender: TObject);
    procedure sbNewContactClick(Sender: TObject);
    procedure FrameResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetIdent;
    procedure UpdateWelcomePage(Init: boolean = False);
  end;

implementation

uses uGlobal, Unit1, uMissedCalls, uCalling, uComposeSMS;

{$R *.dfm}

{ TfrmInfoView }

procedure TfrmInfoView.GetIdent;
begin
  try
    Form1.TxAndWait('AT+CGMI');
    lbManufacturer.Caption := Form1.FRxBuffer[0];
  except
    lbManufacturer.Caption := '?';
  end;

  try
    Form1.TxAndWait('AT+CGMM');
    lbModel.Caption := Form1.FRxBuffer[0];
  except
    lbModel.Caption := '?';
  end;

  try
    Form1.TxAndWait('AT+CGMR');
    lbSWRevision.Caption := Form1.FRxBuffer[0];
  except
    lbSWRevision.Caption := '?';
  end;

  try
    Form1.TxAndWait('AT+CGSN');
    lbSerialNumber.Caption := Form1.FRxBuffer[0];
  except
    lbSerialNumber.Caption := '?';
  end;
end;

procedure TfrmInfoView.UpdateWelcomePage(Init: boolean);
var
  i: integer;
  s: string;
begin
  { Signal and Power }
  if Form1.FConnectingComplete then begin
    wSignal.Caption := IntToStr(Form1.pbRSSI.Position)+'%';
    wBattery.Caption := IntToStr(Form1.pbPower.Position)+'%';
    if Form1.FBatteryLow then
      wBattery.Font.Color := clRed
    else
      wBattery.ParentFont := True;
  end
  else begin
    wSignal.Caption := '?';
    wBattery.Caption := '?';
  end;
  if Form1.FOnACPower then wCharge.Caption := 'yes'
    else wCharge.Caption := 'no';
  { Inbox and Outbox, Calls }
  i := Form1.GetNewMessagesCounter(Form1.FNodeMsgInbox);
  if i <> 0 then begin
    wInboxNew.Caption := IntToStr(i);
    wInboxNew.Font.Style := wInboxNew.Font.Style + [fsBold];
    wInboxNew.Font.Color := clRed;
    sbReadInbox.Font.Color := clRed;
  end
  else begin
    wInboxNew.Caption := 'none';
    wInboxNew.ParentFont := True;
    sbReadInbox.ParentFont := True;
  end;
  i := Form1.GetNewMessagesCounter(Form1.FNodeMsgOutbox);
  if i <> 0 then begin
    wOutboxNew.Caption := IntToStr(i);
    wOutboxNew.Font.Style := wInboxNew.Font.Style + [fsBold];
    wOutboxNew.Font.Color := clRed;
    sbSendOubox.Enabled := True;
  end
  else begin
    wOutboxNew.Caption := 'none';
    wOutboxNew.ParentFont := True;
    sbSendOubox.Enabled := False;
  end;
  if Form1.ActionMissedCalls.Enabled and (frmCalling <> nil) and (frmCalling.FListCalls.Count > 0) then begin
    i := frmCalling.FListCalls.Count;
    wMissedCallsNum.Caption := IntToStr(i);
    wMissedCallsNum.Font.Style := wMissedCallsNum.Font.Style + [fsBold];
    wMissedCallsNum.Font.Color := clRed;
  end
  else begin
    wMissedCallsNum.Caption := 'none';
    wMissedCallsNum.ParentFont := True;
  end;
  { Address book }
  wMENum.Caption := IntToStr(Form1.FNodeContactsME.Count);
  { Initial update when Welcome page is shown }
  if Init then begin
    { Date and Operator }
    wDate.Caption := FormatDateTime(LongDateFormat,Date);
    if Form1.FShowDiagram and Form1.CanUseEBCA(True) then DiagramPanel.Height := Chart1.Height + 9
      else DiagramPanel.Height := 0;
    s := Form1.FSelOperator;
    if s = '' then s := '?';
    wOperator.Caption := s;
    { Recent Calls }
    lvCalls.Items.BeginUpdate;
    try
      lvCalls.Clear;
      for i := 0 to Form1.FNodeCallsIn.Count-1 do
        with lvCalls.Items.Add do begin
          ImageIndex := Form1.FNodeCallsIn.Item[i].ImageIndex;
          s := TStrings(Form1.FNodeCallsIn.Data)[Form1.FNodeCallsIn.Item[i].StateIndex-1];
          Caption := GetToken(s,0);
          SubItems.Add(GetToken(s,1));
        end;
      for i := 0 to Form1.FNodeCallsOut.Count-1 do
        with lvCalls.Items.Add do begin
          ImageIndex := Form1.FNodeCallsOut.Item[i].ImageIndex;
          s := TStrings(Form1.FNodeCallsOut.Data)[Form1.FNodeCallsOut.Item[i].StateIndex-1];
          Caption := GetToken(s,0);
          SubItems.Add(GetToken(s,1));
        end;
      wRecentCallsNum.Caption := IntToStr(lvCalls.Items.Count);
    finally
      lvCalls.AlphaSort;
      lvCalls.Items.EndUpdate;
    end;
    lvMissed.Items.BeginUpdate;
    try
      lvMissed.Clear;
      for i := 0 to Form1.FNodeCallsMissed.Count-1 do
        with lvMissed.Items.Add do begin
          ImageIndex := Form1.FNodeCallsMissed.Item[i].ImageIndex;
          s := TStrings(Form1.FNodeCallsMissed.Data)[Form1.FNodeCallsMissed.Item[i].StateIndex-1];
          Caption := GetToken(s,0);
          SubItems.Add(GetToken(s,1));
        end;
    finally
      lvMissed.AlphaSort;
      lvMissed.Items.EndUpdate;
    end;
  end;
end;

procedure TfrmInfoView.sbSendOuboxClick(Sender: TObject);
begin
  Form1.ActionConnectionSendOutboxMsgs.Execute;
end;

procedure TfrmInfoView.sbReadSMSClick(Sender: TObject);
begin
  if Sender = sbReadInbox then
    Form1.Explorer.Selected := Form1.FNodeMsgInbox
  else
    Form1.Explorer.Selected := Form1.FNodeMsgArchive;
end;

procedure TfrmInfoView.ListViewResize(Sender: TObject);
begin
  with Sender as TTntListView do begin
    Items.BeginUpdate;
    Columns[1].Width := 100;
    Columns[0].Width := Width - Columns[1].Width - 24;
    Columns[0].Width := Columns[0].Width - 1;
    Items.EndUpdate;
  end;
end;

procedure TfrmInfoView.ListViewCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
begin
  { Show recent first }
  Compare := CompareStr(Item2.SubItems[0],Item1.SubItems[0]);
end;

procedure TfrmInfoView.spMissedClick(Sender: TObject);
begin
  Form1.ActionMissedCalls.Execute;
end;

procedure TfrmInfoView.spNewMsgClick(Sender: TObject);
begin
  Form1.ActionSMSNewMsg.Execute;
end;

procedure TfrmInfoView.sbCheckInboxClick(Sender: TObject);
begin
  Form1.ActionSMSDownloadInbox.Execute;
end;

procedure TfrmInfoView.SpeedButton1Click(Sender: TObject);
begin
  Form1.Explorer.Selected := Form1.FNodeContactsME;
end;

procedure TfrmInfoView.sbMESyncClick(Sender: TObject);
begin
  Form1.ActionSyncPhonebook.Execute;
  // TODO: Restore color on sync no matter from where is invoked
  sbMESync.ParentFont := True;
end;

procedure TfrmInfoView.sbNewContactClick(Sender: TObject);
begin
  if Form1.frmSyncPhonebook.DoEdit(True) then
    sbMESync.Font.Color := clRed;
end;

procedure TfrmInfoView.FrameResize(Sender: TObject);
begin
  Panel1.Width := Width div 2;
end;

end.
