unit uWABSync;

interface

uses
  uContactSync, Classes;
{
type
  TWABContact = class(TContact)
  private
//    FOutlookContact: ContactItem;
  protected
    function Exists: Boolean; override;
  public
//    property OutlookContact: ContactItem read FOutlookContact write FOutlookContact;
  end;

  TWABContactSource = class(TContactSource)
  private
    FFilePath: String;
    AddrBook: IAddrBook;
  protected
    function GetName: String; override;
//    procedure Read(Contact: TWABContact; WABContact: ContactItem);
    procedure OpenWAB;
  public
    destructor Destroy; override;

    function New: TContact; override;
    function Add(Value: TContact): TContact; override;
    procedure Update(Contact, Value: TContact); override;
    procedure Delete(Contact: TContact); override;

    procedure Load; override;

    property FilePath: Strings read FFilePath write FFilePath;
  end;
}
implementation

{ TWABContactSource }
{
function TWABContactSource.Add(Value: TContact): TContact;
var
  Contact: TWABContact;
begin
  Contact := New as TWABContact;
  Contact.Clone(Value);
  Contact.LinkedContact := Value;
  Value.LinkedContact := Contact;
  Contacts.Add(Contact);


  Contact.OutlookContact := Outlook.CreateItem(olContactItem) as ContactItem;
  with Contact.OutlookContact do begin
    Title := Contact.Title;
    FirstName := Contact.Name;
    LastName := Contact.SurName;
    CompanyName := Contact.Organization;
    Email1Address := Contact.Email;
    HomeTelephoneNumber := Contact.HomePhone;
    BusinessTelephoneNumber := Contact.WorkPhone;
    MobileTelephoneNumber := Contact.CellPhone;
    HomeFaxNumber := Contact.FaxPhone;
    OtherTelephoneNumber := Contact.OtherPhone;

    Categories := GetOutlookCategories;

    Save;

    Contact.ID := EntryID;
  end;


  Result := Contact;
end;

procedure TWABContactSource.Delete(Contact: TContact);
begin
  with Contact as TWABContact do begin
//    OutlookContact.Delete;

//    OutlookContact := nil;
  end;
end;

destructor TWABContactSource.Destroy;
begin

  inherited;
end;

function TWABContactSource.GetName: String;
begin

end;

procedure TWABContactSource.Load;
var I: Integer;
//    OutlookContact: ContactItem;
    Contact: TWABContact;
begin

  for I := 1 to OutlookContacts.Items.Count do
    if Supports(OutlookContacts.Items.Item(I), ContactItem, OutlookContact) then begin
      if InCategories(OutlookContact) then begin
        Contact := Contacts.FindByID(OutlookContact.EntryID) as TOutlookContact;

        if Assigned(Contact) then begin
          Contact.OutlookContact := OutlookContact;
        end
        else begin
          Contact := New as TOutlookContact;
          Contact.ID := OutlookContact.EntryID;
          Contact.SyncHash := Contact.Hash;
          Contact.OutlookContact := OutlookContact;
          Contacts.Add(Contact);
        end;

        Read(Contact, OutlookContact);
      end;

      Application.ProcessMessages;
    end;

end;

function TWABContactSource.New: TContact;
begin
  Result := TWABContact.Create(Self);
end;

procedure TWABContactSource.OpenWAB;
  ZeroMemory(@WP, Sizeof(WP));
  WP.cbSize := Sizeof(WP);
  WP.szFileName := PChar(FileName);
  WP.hwnd := Application.Handle;
  OleCheck(WabOpen(AddrBook, WabObject, @WP, 0));
end;

procedure TWABContactSource.Update(Contact, Value: TContact);
begin

  with (Contact as TOutlookContact).OutlookContact do begin
    Title := Value.Title;
    FirstName := Value.Name;
    LastName := Value.SurName;
    CompanyName := Value.Organization;
    Email1Address := Value.Email;
    HomeTelephoneNumber := DeformatPhoneNumber(Value.HomePhone);
    BusinessTelephoneNumber := DeformatPhoneNumber(Value.WorkPhone);
    MobileTelephoneNumber := DeformatPhoneNumber(Value.CellPhone);
    HomeFaxNumber := DeformatPhoneNumber(Value.FaxPhone);
    OtherTelephoneNumber := DeformatPhoneNumber(Value.OtherPhone);

    Save;
  end;

end;
}
{ TWABContact }
{
function TWABContact.Exists: Boolean;
begin
//  Result := Assigned(FOutlookContact);
end;
}
end.
